class Sprache {

	final static int SIZE = 3;

	String wort;
	String[] satz;
	int next;

	public Sprache() {
		this.wort = "";
		this.satz = null;
		this.next = 0;
	}

	public Sprache(String wort) {
		this.init(wort);
	}

	public Sprache(Sprache sprache) {
		this.wort = new String(sprache.wort);
		this.satz = new String[Sprache.SIZE];
		for (int i = 0; i < sprache.next; i++) {
			this.satz[i] = new String(sprache.satz[i]);
		}
		this.next = sprache.next;
	}

	protected void init(String wort) {
		this.wort = wort;
		this.next = 0;
		this.satz = new String[Sprache.SIZE];
		this.satz[this.next++] = wort;
	}

	public void append(Sprache sprache) {
		if (this.next < Sprache.SIZE) {
			this.satz[this.next++] = sprache.wort;
		}
	}
}

class Deutsch extends Sprache {

	public Deutsch(String wort) {
		super(wort);
	}

	public Deutsch(Sprache sprache) {
		super(sprache);
	}

	public String toString() {
		StringBuffer speicher = new StringBuffer("");
		for (int i = 0; i < this.next; i++) {
			speicher.append(this.satz[i] + " ");
		}
		return speicher.toString();
	}

}

class Englisch extends Sprache {

	public Englisch(String wort) {
		super();
		if (wort.equals("i")) {
			this.init("ich");
		} else if (wort.equals("am")) {
			this.init("bin");
		} else if (wort.equals("happy")) {
			this.init("gluecklich");
		}
	}

	public Englisch(Sprache sprache) {
		super(sprache);
	}

	public String toString() {
		StringBuffer speicher = new StringBuffer("");
		for (int i = 0; i < this.next; i++) {
			if (this.satz[i].equals("ich")) {
				speicher.append("i ");
			} else if (this.satz[i].equals("bin")) {
				speicher.append("am ");
			} else if (this.satz[i].equals("gluecklich")) {
				speicher.append("happy ");
			}
		}
		return speicher.toString();
	}

}

class Franzoesisch extends Sprache {

	public Franzoesisch(String wort) {
		super();
		if (wort.equals("je")) {
			this.init("ich");
		} else if (wort.equals("suis")) {
			this.init("bin");
		} else if (wort.equals("heureux")) {
			this.init("gluecklich");
		}
	}

	public Franzoesisch(Sprache sprache) {
		super(sprache);
	}

	public String toString() {
		StringBuffer speicher = new StringBuffer("");
		for (int i = 0; i < this.next; i++) {
			if (this.satz[i].equals("ich")) {
				speicher.append("je ");
			} else if (this.satz[i].equals("bin")) {
				speicher.append("suis ");
			} else if (this.satz[i].equals("gluecklich")) {
				speicher.append("heureux ");
			}
		}
		return speicher.toString();
	}

}

class Hessisch extends Sprache {

	public Hessisch(String wort) {
		super();
		if (wort.equals("isch")) {
			this.init("ich");
		} else if (wort.equals("bin")) {
			this.init("bin");
		} else if (wort.equals("gluecklisch")) {
			this.init("gluecklich");
		}
	}

	public Hessisch(Sprache sprache) {
		super(sprache);
	}

	public String toString() {
		StringBuffer speicher = new StringBuffer("");
		for (int i = 0; i < this.next; i++) {
			if (this.satz[i].equals("ich")) {
				speicher.append("isch ");
			} else if (this.satz[i].equals("bin")) {
				speicher.append("bin ");
			} else if (this.satz[i].equals("gluecklich")) {
				speicher.append("gluecklisch ");
			}
		}
		return speicher.toString();
	}

}

public class UE18Aufgabe8 {

	public static void main(String[] args) {

		Franzoesisch f = new Franzoesisch("je");
		Deutsch d = new Deutsch("bin");
		Englisch e = new Englisch("happy");

		Deutsch satz1 = new Deutsch(f);
		satz1.append(d);
		satz1.append(e);

		Englisch satz2 = new Englisch(f);
		satz2.append(d);
		satz2.append(e);

		Franzoesisch satz3 = new Franzoesisch(f);
		satz3.append(d);
		satz3.append(e);

		Deutsch satz4 = new Deutsch(e);
		satz4.append(d);
		satz4.append(f);

		Hessisch satz5 = new Hessisch(f);
		satz5.append(d);
		satz5.append(e);

		System.out.println(satz1);
		// Ausgabe: "ich bin gluecklich"

		System.out.println(satz2);
		// Ausgabe: "i am happy"

		System.out.println(satz3);
		// Ausgabe: "je suis heureux"

		System.out.println(satz4);
		// Ausgabe: "gluecklich bin ich"

		System.out.println(satz5);
		// Ausgabe: "isch bin gluecklisch"

	}
}

